#
# Spec file for packaging OFED kernel modules (and corresponding
# header files).
#

%define kversion 2.6.32-100.21.1.el5

Name:		ofa-%{kversion}
Summary:	OpenFabrics Infiniband Kernel Modules
Prereq:		/sbin/ldconfig
Version:	1.5.1
Release:	4.0.23
License:	GPL/BSD
Url:		http://www.openfabrics.org/
Group:		System Environment/Base
Source:		ofa_kernel-%{version}.tgz

Patch0:		less-verbose-build.patch
#Patch1:		ib-bonding-configure.patch
#Patch2:		ib-bonding-source.patch

# RDS patches
Patch101:	rds-updates.diff
Patch102:	ipoib-least-attached.diff
Patch103:	rds-sg-init-table.diff
Patch104:	rds-rmmod-zach-2.diff
Patch106:	rds-init-mem.patch
Patch107:	rds-track-sends.patch
Patch108:	rds-two-cq.diff
Patch110:	rds-ib-ring-race.diff
Patch111:	rds-fmr-flush-often.diff
Patch112:	0001-RDS-IB-print-IB-event-strings-as-well-as-their-numbe.patch
Patch113:	0002-RDS-IB-protect-the-list-of-IB-devices.patch
Patch114:	0003-Use-CQ_NEXT_COMP-for-recv-completions.patch
Patch115:	0004-RDS-lock-rds_conn_count-decrement-in-rds_conn_destro.patch
Patch116:	0005-RDS-remove-old-rs_transport-comment.patch
Patch117:	0006-RDS-have-sockets-get-transport-module-references.patch
Patch118:	0007-RDS-don-t-call-rds_conn_shutdown-from-rds_conn_destr.patch
Patch119:	0008-RDS-cancel-connection-work-structs-as-we-shut-down.patch
Patch120:	0009-Fix-loopback-connection-reference-counts.patch
Patch121:	ipoib-test-fix.diff
Patch122:	ipoib-neigh-ref.diff
Patch123:	ipoib-no-rmmod.diff
Patch124:	ipoib-not-world-writable.patch
Patch126:	only-warn-once-on-leaked-frag.diff
Patch127:	rds-ib-always-free-recv-frag.patch
Patch128:	rds-security.diff

BuildRoot:	%{?build_root:%{build_root}}%{!?build_root:/var/tmp/OFED}
Vendor:		OpenFabrics
Requires:       kernel = %{kversion}
BuildRequires:  kernel-devel = %{kversion}
#BuildRequires:	sysfsutils-devel

%description
Infiniband kernel modules, providing the core functionality including
the IB verbs layer, drivers for a variety of adapters, management
modules, and upper layer protocols. This package is compiled for
the default kernel.

# Turn ons and offs
%define builddef        1
%define buildpae        0
%define buildxen        0
%define builddebug      1

%ifarch i686
%define karch		i686
%define buildpae        1
%define buildxen        1
%define builddebug      1
%endif

%ifarch x86_64
%define karch		x86_64
%define buildxen        0
%define builddebug      1
%endif

%define KVERREL %{kversion}

%if %{buildpae}
%package -n %{name}PAE
Summary:        OpenFabrics Infiniband Kernel Modules for the PAE kernel
Group:          System Environment/Base
Requires:       kernel-PAE = %{kversion}
BuildRequires:  kernel-PAE-devel = %{kversion}

%description -n %{name}PAE
Infiniband kernel modules, providing the core functionality including
the IB verbs layer, drivers for a variety of adapters, management
modules, and upper layer protocols. This package is compiled for 
the PAE kernel.
%endif

%if %{buildxen}
%package -n %{name}xen
Summary:        OpenFabrics Infiniband Kernel Modules for the xen kernel
Group:          System Environment/Base
Requires:       kernel-xen = %{kversion}
BuildRequires:  kernel-xen-devel = %{kversion}

%description -n %{name}xen
Infiniband kernel modules, providing the core functionality including
the IB verbs layer, drivers for a variety of adapters, management
modules, and upper layer protocols. This package is compiled for
the xen kernel.
%endif

%if %{builddebug}
%package -n %{name}debug
Summary:        OpenFabrics Infiniband Kernel Modules for the debug kernel
Group:          System Environment/Base
Requires:       kernel-debug = %{kversion}
BuildRequires:  kernel-debug-devel = %{kversion}

%description -n %{name}debug
Infiniband kernel modules, providing the core functionality including
the IB verbs layer, drivers for a variety of adapters, management
modules, and upper layer protocols. This package is compiled for
the debug kernel.
%endif


%prep

%setup -q -n ofa_kernel-%{version}
%patch0 -p1
#%patch1 -p1
#%patch2 -p1

# RDS patches
%patch101 -p1
%patch102 -p1
%patch103 -p1
%patch104 -p1
%patch106 -p1
%patch107 -p1
%patch108 -p1
%patch110 -p1
%patch111 -p1
%patch112 -p1
%patch113 -p1
%patch114 -p1
%patch115 -p1
%patch116 -p1
%patch117 -p1
%patch118 -p1
%patch119 -p1
%patch120 -p1
%patch121 -p1
%patch122 -p1
%patch123 -p1
%patch124 -p1
%patch126 -p1
%patch127 -p1
%patch128 -p1

#sh ./configure.bonding  --kernel-version %{kversion}

%build
rm -rf $RPM_BUILD_ROOT

local_configure()
{
# This freakin stupid rpmbuild 4.4.2 doesn't seem to understand
# line continuations via backslash :-(
# Hence this gobbledigook
options="
 --kernel-version="$1"
 --modules-dir=/lib/modules/"$1"
 --kernel-sources=/usr/src/kernels/"$1"
 --without-quilt
 --with-rds-mod
 --with-core-mod
 --with-ipoib-mod
 --with-ipoib-cm
 --with-user_mad-mod
 --with-user_access-mod
 --with-addr_trans-mod
 --with-madeye-mod
 --with-mthca-mod
 --with-mlx4-mod
 --with-cxgb3-mod
 --with-nes-mod
 --with-rds-mod
 --with-sdp-mod
 --with-srp-mod
 --with-srp-target-mod
 --with-mlx4_vnic-mod
"
# --with-iser-mod
#"
./configure $options
}

%if %{builddef}
local_configure "%{KVERREL}"

make
make install_kernel DESTDIR=$RPM_BUILD_ROOT # MODULES_DIR=%{LIB_MOD_DIR}

MOD_DIR=$RPM_BUILD_ROOT/lib/modules/%{KVERREL}
modules_dir=`ls -d $MOD_DIR`
if [ -d $modules_dir/kernel ]; then
   mv $modules_dir/kernel $modules_dir/updates
fi

make clean_kernel

# Build the list of files to include. It's easier to do it this
# way that trying to figure out exactly which kernel modules get
# built and installed.
(
	cd $RPM_BUILD_ROOT
	find lib/modules/%{KVERREL}/updates -type f | sed 's:^:/:'
) > files-def
%endif

%if %{buildpae}
local_configure "%{KVERREL}PAE"

make
make install_kernel DESTDIR=$RPM_BUILD_ROOT # MODULES_DIR=%{LIB_MOD_DIR}

MOD_DIR=$RPM_BUILD_ROOT/lib/modules/%{KVERREL}PAE
modules_dir=`ls -d $MOD_DIR`
if [ -d $modules_dir/kernel ]; then
   mv $modules_dir/kernel $modules_dir/updates
fi

make clean_kernel

# Build the list of files to include. It's easier to do it this
# way that trying to figure out exactly which kernel modules get
# built and installed.
(
	cd $RPM_BUILD_ROOT
	find lib/modules/%{KVERREL}PAE/updates -type f | sed 's:^:/:'
) > files-pae

%endif

%if %{buildxen}
local_configure "%{KVERREL}xen"

make
make install_kernel DESTDIR=$RPM_BUILD_ROOT # MODULES_DIR=%{LIB_MOD_DIR}

MOD_DIR=$RPM_BUILD_ROOT/lib/modules/%{KVERREL}xen
modules_dir=`ls -d $MOD_DIR`
if [ -d $modules_dir/kernel ]; then
   mv $modules_dir/kernel $modules_dir/updates
fi

make clean_kernel

# Build the list of files to include. It's easier to do it this
# way that trying to figure out exactly which kernel modules get
# built and installed.
(
	cd $RPM_BUILD_ROOT
	find lib/modules/%{KVERREL}xen/updates -type f | sed 's:^:/:'
) > files-xen

%endif

%if %{builddebug}
local_configure "%{KVERREL}.debug"

make
make install_kernel DESTDIR=$RPM_BUILD_ROOT # MODULES_DIR=%{LIB_MOD_DIR}

MOD_DIR=$RPM_BUILD_ROOT/lib/modules/%{KVERREL}.debug
modules_dir=`ls -d $MOD_DIR`
if [ -d $modules_dir/kernel ]; then
   mv $modules_dir/kernel $modules_dir/updates
fi

make clean_kernel

# Build the list of files to include. It's easier to do it this
# way that trying to figure out exactly which kernel modules get
# built and installed.
(
	cd $RPM_BUILD_ROOT
	find lib/modules/%{KVERREL}.debug/updates -type f | sed 's:^:/:'
) > files-debug

%endif

%install
# Do nothing here

%clean
rm -rf "$RPM_BUILD_ROOT"

%if %{builddef}
%post
/sbin/depmod -ae %{KVERREL}

%postun
/sbin/depmod -ae %{KVERREL}

%files -f files-def
%defattr(-,root,root)
%endif

%if %{buildpae}
%post -n %{name}PAE
/sbin/depmod -ae %{KVERREL}PAE

%postun -n %{name}PAE
/sbin/depmod -ae %{KVERREL}PAE

%files -f files-pae -n %{name}PAE
%defattr(-,root,root)
%endif

%if %{buildxen}
%post -n %{name}xen
/sbin/depmod -ae %{KVERREL}xen

%postun -n %{name}xen
/sbin/depmod -ae %{KVERREL}xen

%files -f files-xen -n %{name}xen
%defattr(-,root,root)
%endif

%if %{builddebug}
%post -n %{name}debug
/sbin/depmod -ae %{KVERREL}.debug

%postun -n %{name}debug
/sbin/depmod -ae %{KVERREL}.debug

%files -f files-debug -n %{name}debug
%defattr(-,root,root)
%endif

%changelog
* Fri Oct 22 2010 Chris Mason - 1.5.1-4.0.23
- Fix rds permissions checks during copies

* Sat Sep 25 2010 Chris Mason - 1.5.1-4.0.21
- Update to BXOFED 1.5.1-1.3.6-5

* Sat Sep 25 2010 Chris Mason - 1.5.1-4.0.20
- Enable debug builds

* Thu Sep 16 2010 Chris Mason - 1.5.1-4.0.20
- Fix rds frag leak

- Drop the backout for bug 2014, it is causing connection resets
* Tue Sep 14 2010 Chris Mason - 1.5.1-4.0.19
- Drop the backout for bug 2014, it is causing connection resets

* Fri Sep 10 2010 Chris Mason - 1.5.1-4.0.18
- Add BXOFED

* Thu Sep 09 2010 Chris Mason - 1.5.1-4.0.17
- Avoid warning floods for leaked frags

* Fri Aug 27 2010 Chris Mason - 1.5.1-4.0.16
- Fix IP addressing problem, allows rds-ping to work between two cards on the same box

* Tue Aug 24 2010 Chris Mason - 1.5.1-4ofadevel14
- Don't make ipoib child interface sysfs files world writable

* Tue Aug 24 2010 Chris Mason - 1.5.1-4ofadevel13
- Don't allow ipoib to rmmod, it crashes

* Mon Aug 23 2010 Chris Mason - 1.5.1-4ofadevel12
- Add reference to neighbor struct to avoid memory corruption

* Sat Aug 21 2010 Chris Mason - 1.5.1-4ofadevel12
- Add test fix for ipoib corruption

* Thu Aug 05 2010 Chris Mason - 1.5.1-4ofadevel11
- Pull rmmod fixes and connection tear down fixes

* Fri Jul 20 2010 Chris Mason - 1.5.1-4ofadevel10
- Update rds-fmr-flush-often.diff to ofadevel10
  This makes sure the flush thread is usually woken up by allocating
  procs instead of at interrupt time

* Fri Jul 19 2010 Chris Mason - 1.5.1-4ofadevel9
- Update to the rds development tree
- Spread send/recive cqs

* Fri Apr 23 2010 Andy Grover <andy.grover@oracle.com> - 1.5.1-4ofatest13
- Add patches
  0004-RDS-Destroy-unconnected-connections-after-5-minutes.patch
  0005-RDS-cleanup-remove-NULL-s-and-NULL-s-in-pt.patch
  0006-RDS-break-out-rdma-and-data-ops-into-nested-structs.patch
  0007-RDS-cleanup-fix-rds_rdma_unuse.patch
  0008-RDS-Explicitly-allocate-rm-in-sendmsg.patch
  0009-RDS-fold-rdma.h-into-rds.h.patch
  0010-RDS-make-m_rdma_op-a-member-of-rds_message.patch
  0011-RDS-fix-backwards-logic-test.patch
  0012-RDS-make-sure-all-sgs-alloced-are-initialized.patch
  0013-RDS-Clear-up-some-confusing-code-in-send_remove_fro.patch
  0014-RDS-Implement-atomic-operations.patch
  0015-RDS-Base-init_depth-and-responder_resources-on-hw-v.patch
  0016-RDS-Do-not-mask-address-when-pinning-pages.patch
  0017-RDS-Whitespace.patch
  0018-RDS-inc_purge-transport-function-unused-remove.patch
  0019-RDS-IB-eliminate-duplicate-code.patch
  0020-RDS-IB-Disallow-connections-less-than-RDS-3.1.patch
  0021-RDS-IB-Remove-dead-code.patch
  0022-RDS-IB-Remove-ib_-header-data-_sge-functions.patch
  0023-RDS-rewrite-rds_ib_xmit.patch
  0024-RDS-Remove-unsignaled_bytes-sysctl.patch
  0025-RDS-IB-Make-all-flow-control-code-conditional-on-i_.patch
  0026-RDS-Move-loop-only-function-to-loop.c.patch
  0027-RDS-Implement-silent-atomics.patch
  0028-RDS-Inline-rdma_prepare-into-cmsg_rdma_args.patch
  0029-RDS-purge-atomic-resources-too-in-rds_message_purge.patch
  0030-RDS-Remove-struct-rds_rdma_op.patch
  0031-RDS-Rename-data-op-members-prefix-from-m_-to-op_.patch
  0032-RDS-Rewrite-rds_send_xmit.patch
  0033-RDS-Do-not-set-op_active-in-r_m_copy_from_user.patch
  0034-RDS-Add-a-warning-if-trying-to-allocate-0-sgs.patch
  0035-RDS-queue-failure-notifications-for-dropped-atomic.patch
  0036-RDS-Move-some-variables-around-for-consistency.patch
  0037-RDS-Add-flag-for-silent-ops.-Do-atomic-op-before-RD.patch
  0038-RDS-Make-sure-cmsgs-aren-t-used-in-improper-ways.patch
  0039-RDS-Perform-unmapping-ops-in-stages.patch
  0040-RDS-IB-Do-not-wait-for-send-ring-to-be-empty-on-con.patch
  0041-RDS-Stop-supporting-old-cong-map-sending-method.patch
  0042-RDS-Refill-recv-ring-directly-from-tasklet.patch
  0043-RDS-Unify-send-and-recv-CQs.patch
  0044-RDS-Change-send-lock-from-a-mutex-to-a-spinlock.patch
  0045-RDS-rds_send_xmit-locking-irq-fixes.patch
  0046-RDS-Call-rds_send_xmit-directly-from-sendmsg.patch
  0047-RDS-Bypass-workqueue-when-queueing-cong-updates.patch
  0048-RDS-Use-NOWAIT-in-message_map_pages.patch
  0049-RDS-Fix-locking-in-send-on-m_rs_lock.patch
  0050-RDS-rds_message_unmapped-doesn-t-need-to-check-if.patch
  0051-RDS-Move-atomic-stats-from-general-to-ib-specific-a.patch
  0052-RDS-Remove-send_quota-from-send_xmit.patch
  0053-RDS-Do-wait_event_interruptible-instead-of-wait_eve.patch
  0054-RDS-Get-pong-working-again.patch
  0055-RDS-Use-a-generation-counter-to-avoid-rds_send_xmit.patch
  0056-RDS-Update-comments-in-rds_send_xmit.patch
  0057-cmason-switch-to-rwlock-on-bind_lock.patch
  0058-cmason-mlx4-only-get-max-17-vectors.patch
  0059-cmason-per-rm-flush_wait-waitq.patch
  0060-cmason-rcu-ize-ib_get_device.patch
  0061-RDS-Limit-CQEs-handled-in-tasklet.patch
  0062-ib-add-_to_node-macros-for-numa-and-use-k-v-mall.patch
  0063-RDS-IB-Remove-unused-variable-in-ib_remove_addr.patch

* Tue Apr 13 2010 Andy Grover <andy.grover@oracle.com> - 1.5.1-4
- Add patches
  0002-RDS-Rewrite-rds_send_drop_to-for-clarity.patch
  0003-RDS-Fix-locking-in-send-on-m_rs_lock.patch

* Tue Apr 06 2010 Andy Grover <andy.grover@oracle.com> - 1.5.1-3
- Add patches
  0001-RDS-Fix-corrupted-rds_mrs.patch

* Thu Mar 25 2010 Andy Grover <andy.grover@oracle.com> - 1.5.1-2
- Update to 1.5.1-GA

* Wed Mar 3 2010 Andy Grover <andy.grover@oracle.com> - 1.5.1-1
- Update to 1.5.1-rc2
- Remove patches
  0001-RDS-update-copy_to_user-state-in-tcp-transport.patch
  0002-RDS-use-IB_CQ_VECTOR_LEAST_ATTACHED-for-cq-s.patch
  0003-RDS-TCP-Wait-to-wake-thread-when-write-space-availa.patch
  0004-RDS-Fix-congestion-issues-for-loopback.patch
  0005-RDS-Fix-send-locking-issue.patch

* Wed Feb 17 2010 Andy Grover <andy.grover@oracle.com> - 1.5-1
- Initial packaging of OFED 1.5 for OEL5
- Add patches
  0001-RDS-update-copy_to_user-state-in-tcp-transport.patch
  0002-RDS-use-IB_CQ_VECTOR_LEAST_ATTACHED-for-cq-s.patch
  0003-RDS-TCP-Wait-to-wake-thread-when-write-space-availa.patch
  0004-RDS-Fix-congestion-issues-for-loopback.patch
  0005-RDS-Fix-send-locking-issue.patch
